<?php
/**
 * @Ctcms open source management system
 * @copyright 2016-2017 ctcms.cn. All rights reserved.
 * @Author:Chi Tu
 * @Dtime:2016-08-11
 */
defined('BASEPATH') OR exit('No direct script access allowed');

class App extends Ctcms_Controller {

	function __construct(){
	    parent::__construct();
		//加载后台模型
		$this->load->model('admin');
        //当前模版
		$this->load->get_templates('admin');
		//判断是否登陆
		$this->admin->login();
	}

	public function index()
	{
		//判断APP需要字段
		if(!$this->db->table_exists(CT_SqlPrefix.'zan')){
			$sql = "CREATE TABLE `".CT_SqlPrefix."zan` (
			  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			  `uid` int(11) unsigned DEFAULT '0' COMMENT '点赞用户',
			  `did` int(11) DEFAULT '0' COMMENT '视频id',
			  `addtime` int(10) DEFAULT '0' COMMENT '点赞时间',
			  PRIMARY KEY (`id`),
			  KEY `uid_did` (`uid`,`did`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->query($sql);
			$sql="ALTER TABLE ".CT_SqlPrefix."vod ADD pf float(4,1) DEFAULT '10.0'";
			$this->db->query($sql);
			$sql="ALTER TABLE ".CT_SqlPrefix."vod ADD dhits int(10) unsigned DEFAULT '0'";
			$this->db->query($sql);
			$sql = "CREATE TABLE `".CT_SqlPrefix."shikan` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `num` int(11) unsigned DEFAULT '0',
			  `ip` varchar(20) DEFAULT '',
			  `day` varchar(10) DEFAULT '0',
			  PRIMARY KEY (`id`),
			  KEY `ip` (`ip`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->query($sql);
			$sql = "CREATE TABLE `".CT_SqlPrefix."pl_zan` (
			  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			  `uid` int(11) unsigned DEFAULT '0' COMMENT '点赞用户',
			  `did` int(11) DEFAULT '0' COMMENT '评论id',
			  `addtime` int(10) DEFAULT '0' COMMENT '点赞时间',
			  PRIMARY KEY (`id`),
			  KEY `uid_did` (`uid`,`did`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->query($sql);
			$sql="ALTER TABLE ".CT_SqlPrefix."pl ADD ding int(10) unsigned DEFAULT '0'";
			$this->db->query($sql);
		}

 		$this->load->view('head.tpl');
		$this->load->view('app.tpl');
	}

	public function save()
	{
		$CT_App_Ios_Ver = $this->input->post('CT_App_Ios_Ver', TRUE);
		$CT_App_Android_Ver = $this->input->post('CT_App_Android_Ver', TRUE);
		$CT_App_Ads_Pic1 = $this->input->post('CT_App_Ads_Pic1', TRUE);
		$CT_App_Ads_Url1 = $this->input->post('CT_App_Ads_Url1', TRUE);
		$CT_App_Ads_Pic2 = $this->input->post('CT_App_Ads_Pic2', TRUE);
		$CT_App_Ads_Url2 = $this->input->post('CT_App_Ads_Url2', TRUE);
		$CT_App_Ads_Pic3 = $this->input->post('CT_App_Ads_Pic3', TRUE);
		$CT_App_Ads_Url3 = $this->input->post('CT_App_Ads_Url3', TRUE);
		$CT_App_Kalink = $this->input->post('CT_App_Kalink', TRUE);
		$CT_App_Ios_Url = $this->input->post('CT_App_Ios_Url', TRUE);
		$CT_App_Android_Url = $this->input->post('CT_App_Android_Url', TRUE);
		$CT_App_Jxurl = $this->input->post('CT_App_Jxurl', TRUE);
		$CT_App_Sktime = (int)$this->input->post('CT_App_Sktime', TRUE);
		$CT_App_Paytype = $this->input->post('CT_App_Paytype');
		$CT_App_Paytype = implode('|',$CT_App_Paytype);


		$strs="<?php"."\r\n";
		$strs.="define('CT_App_Ios_Ver','".$CT_App_Ios_Ver."'); //苹果APP版本号  \r\n";
		$strs.="define('CT_App_Android_Ver','".$CT_App_Android_Ver."'); //安卓APP版本号  \r\n";
		$strs.="define('CT_App_Ads_Pic1','".$CT_App_Ads_Pic1."'); //APP主页横幅图片  \r\n";
		$strs.="define('CT_App_Ads_Url1','".$CT_App_Ads_Url1."'); //APP主页横幅链接  \r\n";
		$strs.="define('CT_App_Ads_Pic2','".$CT_App_Ads_Pic2."'); //APP列表页横幅图片  \r\n";
		$strs.="define('CT_App_Ads_Url2','".$CT_App_Ads_Url2."'); //APP列表页横幅链接  \r\n";
		$strs.="define('CT_App_Ads_Pic3','".$CT_App_Ads_Pic3."'); //APP播放页横幅图片  \r\n";
		$strs.="define('CT_App_Ads_Url3','".$CT_App_Ads_Url3."'); //APP播放页横幅链接  \r\n";
		$strs.="define('CT_App_Kalink','".$CT_App_Kalink."');  //点卡购买地址  \r\n";
		$strs.="define('CT_App_Ios_Url','".$CT_App_Ios_Url."');  //苹果APP更新地址  \r\n";
		$strs.="define('CT_App_Android_Url','".$CT_App_Android_Url."');  //安卓APP更新地址  \r\n";
		$strs.="define('CT_App_Jxurl','".$CT_App_Jxurl."');  //APP解析地址  \r\n";
		$strs.="define('CT_App_Sktime',".$CT_App_Sktime.");  //收费视频试看秒数  \r\n";
		$strs.="define('CT_App_Paytype','".$CT_App_Paytype."');  //APP付款方式  ";

        //写文件
        if (!write_file(CTCMSPATH.'libs/Ct_App.php', $strs)){
             admin_msg('抱歉，修改失败，请检查文件写入权限~!',links('app'),'no');
		}else{
             admin_msg('恭喜您，配置修改成功~！',links('app'));
		}
	}
}
